add autoconfig parameter to change GRMLCFG label [Closes: issue673]
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8
9 # {{{ path, variables, signals, umask, zsh
10 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
11 DEBUG="/dev/null"
12 KERNEL="$(uname -r)"
13 ARCH="$(uname -m)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 # {{{ Read in boot parameters
37 if [ -z "$CMDLINE" ]; then
38   # if CMDLINE was set from the outside, we're debugging.
39   # otherwise, take CMDLINE from Kernel and config files.
40   CMDLINE="$(cat /proc/cmdline)"
41   [ -d /cdrom/bootparams/ ]      && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
42   [ -d /live/image/bootparams/ ] && CMDLINE="$CMDLINE $(cat /live/image/bootparams/* | tr '\n' ' ')"
43 fi
44 # }}}
45
46 ### {{{ Utility Functions
47
48 # Get a bootoption's parameter: read boot command line and either
49 # echo last parameter's argument or return false.
50 getbootparam(){
51   local line
52   local ws
53   ws='   '
54   line=" $CMDLINE "
55   case "$line" in
56     *[${ws}]"$1="*)
57       result="${line##*[$ws]$1=}"
58       result="${result%%[$ws]*}"
59       echo "$result"
60       return 0 ;;
61     *) # no match?
62       return 1 ;;
63   esac
64 }
65
66 # Check boot commandline for specified option
67 checkbootparam(){
68   [ -n "$1" ] || ( echo "Error: missing argument to checkbootparam()" ; return 1 )
69   local line
70   local ws
71   ws='   '
72   line=" $CMDLINE "
73   case "$line" in
74     *[${ws}]"$1"=*|*[${ws}]"$1"[${ws}]*)
75       return 0 ;;
76     *)
77       return 1 ;;
78   esac
79 }
80
81 # Check if currently using a framebuffer
82 hasfb() {
83     [ -e /dev/fb0 ] && return 0 || return 1
84 }
85
86 # Check wheter a configuration variable (like $CONFIG_TOHD) is
87 # enabled or not
88 checkvalue(){
89   case "$1" in
90     [yY][eE][sS])     return 0 ;; # it's set to 'yes'
91     [tT][rR][uU][eE]) return 0 ;; # it's set to 'true'
92                    *) return 1 ;; # default
93   esac
94 }
95
96 # Are we using grml-small?
97 checkgrmlsmall(){
98   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
99 }
100
101 # execute flite only if it's present
102 flitewrapper() {
103    [ -x /usr/bin/flite ] && flite -o play -t "$*"
104 }
105 ### }}}
106
107 # {{{ filesystems (proc, pts, sys) and fixes
108 mount_proc(){
109   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
110 }
111
112 mount_pts(){
113   grep -q "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
114 }
115
116 mount_sys(){
117   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
118 }
119 # }}}
120
121 # {{{ Check if we are running in live mode or from HD
122 INSTALLED=""
123 [ -e /etc/grml_cd ] || INSTALLED="yes"
124
125 # testcd
126 TESTCD=""
127 checkbootparam 'testcd' >>$DEBUG 2>&1 && TESTCD="yes"
128 # }}}
129
130 # {{{ source lsb-functions , color handling
131 if checkbootparam 'nocolor'; then
132   RC_NOCOLOR=yes
133   . /etc/grml/lsb-functions
134   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
135 else
136   . /etc/grml/lsb-functions
137   . /etc/grml_colors
138 fi
139 # }}}
140
141 # {{{ debug
142 config_debug(){
143  checkbootparam 'debug'            && BOOTDEBUG="yes"
144  checkbootparam "BOOT_IMAGE=debug" && BOOTDEBUG="yes"
145
146  rundebugshell(){
147   if [ -n "$BOOTDEBUG" ]; then
148      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
149      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
150         einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
151         einfo "Just exit the shell to continue boot process..."
152         /bin/zsh
153      else
154         eindent
155         if [ -r /etc/grml/screenrc ] ; then
156            einfo "Starting GNU screen to be able to use a full featured shell environment."
157            einfo "Just exit the shells (and therefore screen) to continue boot process..."
158            /bin/zsh -c "screen -c /etc/grml/screenrc"
159         else
160            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
161            einfo "Just exit the shell to continue boot process..."
162            /bin/zsh
163         fi
164         eoutdent
165      fi
166   fi
167  }
168 }
169 # }}}
170
171 # {{{ log
172 config_log(){
173 if checkbootparam 'log' || checkbootparam 'debug' ; then
174    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
175    touch $DEBUG
176    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
177    eindent
178      einfo "Starting bootlogd." # known to be *very* unreliable :(
179      bootlogd -r -c >>$DEBUG 2>&1 ; eend $?
180    eoutdent
181 else
182    DEBUG="/dev/null"
183 fi
184 }
185 # }}}
186
187 # {{{ set firmware timeout via bootparam
188 config_fwtimeout(){
189  if checkbootparam 'fwtimeout' ; then
190    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
191    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
192    rmmod firmware_class >>$DEBUG 2>&1
193    modprobe firmware_class ; eend $?
194  fi
195  if [ -z "$TIMEOUT" ] ; then
196    TIMEOUT="100" # linux kernel default: 10
197  fi
198  if [ -f /sys/class/firmware/timeout ] ; then
199    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
200    echo 100 > /sys/class/firmware/timeout ; eend $?
201  fi
202 }
203 # }}}
204
205 ### {{{ language configuration / localization
206 config_language(){
207
208  einfo "Activating language settings:"
209  eindent
210
211  # people can specify $LANGUAGE and $CONSOLEFONT in a config file
212  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
213
214  # check for bootoption which overrides config from /etc/grml/autoconfig
215  BOOT_LANGUAGE="$(getbootparam 'lang' 2>>$DEBUG)"
216  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
217
218  # set default to 'en' in live-cd mode iff $LANGUAGE is not set yet
219  if [ -z "$INSTALLED" ] ; then
220     [ -n "$LANGUAGE" ] || LANGUAGE='en'
221  fi
222
223  if [ -x /usr/sbin/grml-setlang ] ; then
224    # if bootoption lang is used update /etc/default/locale accordingly
225    if [ -n "$BOOT_LANGUAGE" ] ; then
226      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "$LANGUAGE"
227    # otherwise default to lang=en
228    else
229      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "en"
230    fi
231  fi
232
233  # set console font
234  if [ -z "$CONSOLEFONT" ] ; then
235     if ! checkbootparam 'nodefaultfont' >>$DEBUG 2>&1 ; then
236        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
237           CONSOLEFONT='Uni3-Terminus16'
238        else
239           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
240        fi
241        if ! hasfb ; then
242           CONSOLEFONT='Lat15-Terminus16'
243        fi
244     fi
245  fi
246
247  # export it now, so error messages get translated, too
248  if checkgrmlsmall ; then
249     export LANG='C' # grml-small does not provide any further locales
250  else
251     [ -r /etc/default/locale ] && . /etc/default/locale
252     export LANG LANGUAGE
253  fi
254
255  # configure keyboard layout, read in already set values first:
256  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
257
258  # now allow keyboard override by boot commandline for later use:
259  KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
260  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
261  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
262  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
263  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
264
265  # modify /etc/sysconfig/keyboard only in live-cd mode:
266  if [ -z "$INSTALLED" ] ; then
267
268    local LANGUAGE="$BOOT_LANGUAGE"
269    . /etc/grml/language-functions
270    # allow setting xkeyboard explicitly different than console keyboard
271    KXKEYBOARD="$(getbootparam 'xkeyboard' 2>>$DEBUG)"
272    if [ -n "$KXKEYBOARD" ]; then
273       XKEYBOARD="$KXKEYBOARD"
274       KDEKEYBOARD="$KXKEYBOARD"
275    elif [ -n "$KKEYBOARD" ]; then
276       XKEYBOARD="$KKEYBOARD"
277       KDEKEYBOARD="$KKEYBOARD"
278    fi
279
280    # duplicate of previous code to make sure /etc/grml/language-functions
281    # does not overwrite our values....
282    # now allow keyboard override by boot commandline for later use:
283    KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
284    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
285    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
286    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
287    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
288
289    # write keyboard related variables to file for later use
290    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
291    if ! [ -e /etc/sysconfig/keyboard ] ; then
292       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
293       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
294       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
295       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
296    fi
297  fi
298
299  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
300
301  # activate unicode console if running within utf8 environment
302  if [ -r /etc/default/locale ] ; then
303     if grep -q "LANG=.*UTF" /etc/default/locale ; then
304        einfo "Setting up unicode environment."
305        unicode_start >>$DEBUG 2>&1 ; eend $?
306     fi
307  fi
308
309  # Set default keyboard before interactive setup
310  if [ -n "$KEYTABLE" ] ; then
311     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
312     loadkeys -q $KEYTABLE &
313     eend $?
314  fi
315
316  # we have to set up all consoles, therefore loop it over all ttys:
317  NUM_CONSOLES=$(fgconsole --next-available 2>/dev/null)
318  if [ -n "$NUM_CONSOLES" ] ; then
319     NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
320     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
321  fi
322  CUR_CONSOLE=$(fgconsole 2>/dev/null)
323
324  if [ -x "$(which setfont)" ] ; then
325     use_setfont=true
326  elif [ -x "$(which consolechars)" ] ; then
327     use_consolechars=true
328  else
329     eerror "Neither setfont nor consolechars tool present, can not set font."
330     eend 1
331     return 1
332  fi
333
334  if [ -n "$CHARMAP" ] ; then
335     einfo "Setting font to ${CHARMAP}"
336     RC=0
337     for vc in $(seq 0 ${NUM_CONSOLES}) ; do
338         if $use_setfont ; then
339           setfont -C /dev/tty${vc} $CHARMAP ; RC=$?
340         elif $use_consolechars ; then
341           consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
342         fi
343     done
344     if [ -n "$CUR_CONSOLE" ] ; then
345        [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
346     fi
347     eend $RC
348  fi
349
350  if checkbootparam 'noconsolefont' ; then
351     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
352  else
353     if [ -n "$CONSOLEFONT" ] ; then
354        einfo "Setting font to ${CONSOLEFONT}"
355        RC=0
356        for vc in $(seq 0 ${NUM_CONSOLES}) ; do
357            if $use_setfont ; then
358              setfont -C /dev/tty${vc} ${CONSOLEFONT} ; RC=$?
359            elif $use_consolechars ; then
360              consolechars --tty=/dev/tty${vc} -f ${CONSOLEFONT} ; RC=$?
361            fi
362        done
363        if [ -n "$CUR_CONSOLE" ] ; then
364           [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
365        fi
366        eend $RC
367     fi
368  fi
369
370  eoutdent
371 }
372 # }}}
373
374 # {{{ Set hostname
375 config_hostname(){
376  if checkbootparam 'hostname' ; then
377   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
378   if [ -z "$HOSTNAME" ] && [ -x /usr/bin/random-hostname ] ; then
379      einfo "Generating random hostname as no hostname was specified."
380      HOSTNAME="$(/usr/bin/random-hostname)"
381      eend $?
382   fi
383   einfo "Setting hostname to $HOSTNAME as requested."
384   grml-hostname $HOSTNAME >>$DEBUG ; RC=$?
385   [ "$RC" = "0" ] && hostname $HOSTNAME
386   eend $RC
387  else
388   hostname --file /etc/hostname
389  fi
390 }
391 # }}}
392
393 # fstabuser (needed when running from harddisk with username != grml {{{
394 config_userfstab(){
395   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
396   if [ -n "$CONFIG_FSTAB_USER" ] ; then
397      fstabuser="$CONFIG_FSTAB_USER"
398   else
399      fstabuser=$(getent passwd 1000 | cut -d: -f1)
400   fi
401   # if not yet set fall back to default 'grml' user
402   [ -n "$fstabuser" ] || fstabuser='grml'
403 }
404 # }}}
405
406 # {{{ Set clock (Local time is more often used than GMT, so it is default)
407 config_time(){
408  # don't touch the files if running from harddisk:
409  if [ -z "$INSTALLED" ]; then
410     # The default hardware clock timezone is stated as representing local time.
411     UTC="--localtime"
412     grep -q "^UTC=" /etc/default/rcS || echo "UTC=no" >> /etc/default/rcS
413     checkbootparam 'utc'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
414     checkbootparam 'gmt'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
415     checkbootparam 'localtime' >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=no|"  /etc/default/rcS
416     grep -q -i "^UTC=yes" /etc/default/rcS && UTC="-u"
417     # hwclock uses the TZ variable
418     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
419     [ -z "$KTZ" ] && [ -r /etc/timezone ] && KTZ=$(cat /etc/timezone)
420     if [ ! -f "/usr/share/zoneinfo/$KTZ" ] ; then
421        ewarn "Warning: unknown timezone $KTZ" ; eend 1
422        KTZ="Europe/Vienna"
423        ewarn "Falling back to timezone $KTZ" ; eend 0
424     fi
425
426     if ! [ -r /dev/rtc ] ; then
427       ewarn "Warning: realtime clock not available, trying to execute hwclock anyway." ; eend 0
428     fi
429
430     ERROR=$(TZ="$KTZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
431     if [ -n "$ERROR" ] ; then
432        eindent
433        ERROR=$(TZ="$KTZ" hwclock $UTC -s --directisa 2>&1 | head -1)
434        if [ -n "$ERROR" ] ; then
435           eerror "Problem running hwclock: $ERROR" ; eend 1
436        fi
437        eoutdent
438     fi
439
440  fi
441 }
442 # }}}
443
444 # {{{ print kernel info
445 config_kernel(){
446   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
447   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
448   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
449   if [ -r /proc/cpuinfo ] ; then
450      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
451        eindent
452        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
453        eoutdent
454      fi
455   fi
456   if [ -d /proc/xen ] ; then
457      eindent
458      einfo 'Running kernel featuring support for Xen detected' ; eend 0
459      eoutdent
460   fi
461 }
462 # }}}
463
464 # {{{ ld.so.cache + depmod
465 config_ld_mod(){
466 if [ -n "$INSTALLED" ]; then
467  if ! [ -r /etc/grml.first.boot ] ; then
468   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
469   eindent
470 # Regenerate ld.so.cache and module dependencies on HD
471     einfo "Running ldconfig" ; ldconfig  ; eend $?
472     einfo "Running depmod"   ; depmod -a ; eend $?
473     touch /etc/grml.first.boot
474     eend 0
475   eoutdent
476  fi
477 fi
478 }
479 # }}}
480
481 # {{{ timezone
482 config_timezone(){
483  # don't touch the files if running from harddisk:
484  if [ -z "$INSTALLED" ]; then
485     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
486     if [ -n "$KTZ" ] ; then
487        if [ ! -f "/usr/share/zoneinfo/$KTZ" ]
488        then
489           ewarn "Warning: unknown timezone $KTZ"; eend 0
490        else
491           einfo "Setting timezone."
492           # update debconf
493           area=$(echo $KTZ | cut -d '/' -f1)
494           zone=$(echo $KTZ | cut -d '/' -f2)
495           echo "tzdata tzdata/Areas       select $area" | debconf-set-selections
496           echo "tzdata tzdata/Zones/$area select $zone" | debconf-set-selections
497           # update files
498           echo $KTZ > /etc/timezone
499           rm -f /etc/localtime
500           cp "/usr/share/zoneinfo/$KTZ" /etc/localtime ; eend $?
501        fi
502     fi
503  fi
504 }
505 # }}}
506
507 # small computer / nearly no ram {{{
508 config_small(){
509
510 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
511 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
512 eindent
513
514 if checkbootparam 'small'; then
515   einfo "Information: ${RAM} kB of RAM available." ; eend 0
516   einfo "Bootoption small detected. Activating small system."
517   if [ -r /etc/inittab.small ] ; then
518     mv /etc/inittab /etc/inittab.normal
519     mv /etc/inittab.small /etc/inittab
520   else
521     sed -i 's/^9/#&/' /etc/inittab
522     sed -i 's/^10/#&/' /etc/inittab
523     sed -i 's/^11/#&/' /etc/inittab
524     sed -i 's/^12/#&/' /etc/inittab
525   fi
526   /sbin/telinit q ; eend $?
527 else
528   if checkgrmlsmall ; then
529     if [[ $RAM -lt 25000 ]] ; then
530       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
531       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
532       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
533       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
534       /bin/zsh --login
535     else
536       einfo "Information: ${RAM} kB of RAM available." ; eend 0
537     fi
538   else
539     if [[ $RAM -lt 58000 ]] ; then
540       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
541       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
542       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
543       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
544       /bin/zsh --login
545     else
546       einfo "Information: ${RAM} kB of RAM available." ; eend 0
547     fi
548   fi
549 fi
550 eoutdent
551 }
552 # }}}
553
554 # skip startup of w3m {{{
555 config_fast(){
556 if checkbootparam 'fast'; then
557   ewarn "Bootoption fast detected. Skipping startup of grml-quickconfig."
558     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
559   /sbin/telinit q ; eend $?
560 fi
561 }
562 # }}}
563
564 # activate serial console {{{
565 config_console(){
566 if checkbootparam 'console'; then
567   local line
568   local ws
569   ws='   '
570
571   einfo "Bootoption for serial console detected:"
572
573   line="$CMDLINE x "
574   this=""
575   line="${line#*[$ws]}"
576   local telinitq=""
577   while [ -n "$line" ]; do
578     case "$this" in
579       console=*)
580         local serial="$this"
581         local device="${this%%,*}"
582         local device="${device##*=}"
583         if echo $serial | grep -q ttyS ; then
584           local option="${serial##*,}"
585           # default (works for kvm & CO):
586           local speed="115200,57600,38400,19200,9600,4800,2400,1200";
587           # ... unless overriden by command line:
588           case "$option" in
589             115200*) speed=115200 ;;
590              57600*) speed=57600 ;;
591              38400*) speed=38400 ;;
592              19200*) speed=19200 ;;
593               9600*) speed=9600 ;;
594               4800*) speed=4800 ;;
595               2400*) speed=2400 ;;
596               1200*) speed=1200 ;;
597           esac
598           eindent
599             einfo "Activating console login on device ${device} with speed ${speed}."
600             local number="${device#ttyS}"
601             sed -i "/^T$number:/d;/^#grmlserial#/iT$number:23:respawn:/bin/bash -c \"/sbin/getty -L $device -l /usr/bin/zsh-login $speed vt100 || sleep 30\"" /etc/inittab
602             eend $?
603             telinitq="1"
604           eoutdent
605         fi
606         ;;
607     esac
608     this="${line%%[$ws]*}"
609     line="${line#*[$ws]}"
610   done
611
612   if [ -n "$telinitq" ]; then
613     /sbin/telinit q
614   fi
615   eend $?
616 fi
617 }
618 # }}}
619
620 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
621 config_cdrom_perm(){
622 CDROMS=""
623 for DEVICE in /proc/ide/hd?; do
624  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
625 done
626 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
627 }
628 # }}}
629
630 # {{{ Bring up loopback interface now
631 config_local_net(){
632  if [ -z "$INSTALLED" ] ; then
633     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
634        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
635     else
636        ifconfig lo up
637     fi
638  fi
639 }
640 # }}}
641
642 # firewire devices {{{
643 # the raw1394 driver does not yet export info into SYSFS,
644 # so let's create raw1394 device manually
645 # http://www.michael-prokop.at/blog/index.php?p=352
646 config_firewire_dev(){
647 if checkbootparam 'nofirewiredev' ; then
648   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
649 else
650 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
651   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
652 #  cd /dev && MAKEDEV video1394 raw1394
653   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
654   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
655 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
656   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
657   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
658   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
659 fi
660 #fi
661 }
662 # }}}
663
664 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
665 # otherwise we will get: passwd: Authentication token lock busy
666 config_fix_passwd(){
667  if [ -z "$INSTALLED" ] ; then
668   touch /etc/.pwd.lock
669  fi
670 }
671 # }}}
672
673 # {{{ CD Checker
674 config_testcd(){
675 if [ -n "$TESTCD" ]; then
676    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
677    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
678    echo -n "${RED}"
679
680    if [ -n "${LIVECD_PATH}"/GRML ] ; then
681       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
682    else
683       echo "${RED} *** Error: Could not find md5sum file.                           ***"
684    fi
685
686    if [ "$RC" = "0" ]; then
687       einfo "Everything looks OK" ; eend 0
688    else
689       eerror 'Checksum failed for theses files:' ; eend 1
690       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
691       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
692       eerror '... RAM of your computer is broken.' ; eend 1
693       einfon "Hit return to continue, or press the reset button to quit."
694      read a
695    fi
696
697    eend 0
698 fi
699 }
700 # }}}
701
702 # {{{ hardware detection via discover
703 config_discover(){
704 if checkbootparam 'nodisc' ; then
705   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
706 else
707  if [ -x /sbin/discover ] ; then
708   einfo "Discovering hardware. Trying to load the following modules in background:"
709    eindent
710    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
711    eoutdent
712   /sbin/discover-modprobe -v >>$DEBUG 2>&1 &
713   eend 0
714  else
715   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
716  fi
717 fi
718 }
719 # }}}
720
721 # {{{ hardware detection via hwinfo
722 config_hwinfo(){
723 if checkbootparam 'hwinfo' >>$DEBUG 2>&1; then
724   einfo "Discovering hardware via hwinfo:"
725   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
726   echo -n "  Loading modules: "
727   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
728   eend 0
729 fi
730 }
731 # }}}
732
733 # {{{ disable hotplug agents on request
734 config_hotplug_agent(){
735 if checkbootparam 'noagent' ; then
736   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
737   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
738   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
739   einfo "Disabling hotplug-agent(s) $AGENTNL"
740   for agent in $(echo -e $AGENTLIST) ; do
741     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
742   done
743   [ "$?" == "0" ] ; eend $?
744 fi
745 }
746 # }}}
747
748 # {{{ blacklist of hotplug-modules
749 config_hotplug_blacklist(){
750 if checkbootparam 'black' ; then
751   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
752   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
753   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
754   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
755   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
756   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
757   eend 0
758 fi
759 }
760 # }}}
761
762 # {{{ run hotplug
763 config_hotplug(){
764 if checkbootparam 'nohotplug' ; then
765   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
766 else
767   if [ -r /etc/init.d/hotplug ] ; then
768     einfo "Starting hotplug system in background."
769     /etc/init.d/hotplug start >>$DEBUG 2>>$DEBUG &
770     eend 0
771   elif [ -r /etc/init.d/hotplug-light ] ; then
772     einfo "Starting hotplug-light system in background."
773     /etc/init.d/hotplug-light start >>$DEBUG 2>>$DEBUG &
774     eend 0
775   else
776     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
777   fi
778 fi
779 }
780 # }}}
781
782 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
783 config_blacklist(){
784 if checkbootparam 'blacklist' ; then
785  if [ -z "$INSTALLED" ]; then
786   einfo "Bootoption blacklist found."
787   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
788   BLACKLIST_FILE='/etc/modprobe.d/grml.conf'
789   if [ -n "$BLACK" ] ; then
790     for module in $(echo ${BLACK//,/ }) ; do
791         einfo "Blacklisting module ${module} via ${BLACKLIST_FILE}."
792         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE"
793         echo "blacklist $module"     >> "$BLACKLIST_FILE"
794         echo "alias     $module off" >> "$BLACKLIST_FILE"
795         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE" ; eend $?
796     done
797   else
798    eerror "No given module for blacklist found. Blacklisting will not work therefore."
799   fi
800  else
801   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
802   eindent
803    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
804   eoutdent
805  fi
806 fi
807 }
808 # }}}
809
810 # {{{ ACPI
811 config_acpi_apm(){
812 if [ -d /proc/acpi ]; then
813   if checkbootparam 'noacpi'; then
814     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
815   elif checkbootparam 'nogrmlacpi' ; then
816     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
817   else
818     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
819     eindent
820     found=""
821     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
822       basename="${a##*/}"
823       basename="${basename%%.*}"
824       case "$basename" in *_acpi)
825        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
826       esac
827       modprobe $basename >>$DEBUG 2>&1 && found="yes"
828       local BASE="$BASE $basename"
829     done
830     if [ -n "$found" ] ; then
831       einfo "$BASE"  ; eend 0
832     else
833       ewarn "(none)" ; eend 1
834     fi
835     if ! ps x | grep -q /usr/sbin/acpid ; then
836       if ! [ -r /var/run/dbus/pid ] ; then
837         einfo "Starting acpi daemon."
838         /etc/init.d/acpid start >>$DEBUG 2>&1 ; eend $?
839       else
840         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
841         eerror "Solution: please activate acpid via /etc/runlevel.conf"
842         eend 1
843       fi
844     else
845       ewarn "acpi daemon already running."
846       eend 0
847     fi
848     eoutdent
849   fi
850 else
851 # APM
852   if checkbootparam 'noapm'; then
853     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
854   else
855     modprobe apm power_off=1 >>$DEBUG 2>&1
856     if [ "$?" = "0" ] ; then
857        if [ -x /etc/init.d/apmd ] ;then
858           einfo "APM Bios found, enabling power management functions."
859           /etc/init.d/apmd start ; eend $?
860        fi
861     else
862       eerror "Loading apm module failed." ; eend 1
863     fi
864   fi
865 fi
866 }
867 # }}}
868
869 # {{{ PCMCIA Check/Setup
870 # This needs to be done before other modules are being loaded (by hwsetup)
871 config_pcmcia(){
872 if checkbootparam 'nopcmcia'; then
873   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
874 else
875   if /usr/sbin/laptop-detect ; then
876     einfo "Detected Laptop - checking for PCMCIA." && eend 0
877     modprobe pcmcia_core >>$DEBUG 2>&1
878     # Try Cardbus or normal PCMCIA socket drivers
879     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
880     if [ "$?" = "0" ]; then
881       modprobe ds >>$DEBUG 2>&1
882       if [ -d /proc/bus/pccard ] ; then
883        if [ -x /sbin/cardmgr ] ; then
884         einfo "PCMCIA found, starting cardmgr."
885         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
886        else
887         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
888        fi
889       fi
890     fi
891   fi
892 fi
893 }
894 # }}}
895
896 # {{{ run software synthesizer via speakup
897 config_swspeak(){
898    if checkbootparam 'swspeak' ; then
899       einfo "Bootoption swspeak found."
900
901       if [ ! -d /proc/speakup/ ] && ! grep -q speakup_soft /proc/modules ; then
902          ewarn "Kernel does not support software speakup - trying to load kernel module:" ; eend 0
903          eindent
904          einfo "Loading speakup_soft"
905          if modprobe speakup_soft ; then
906             eend 0
907          else
908             flitewrapper "Fatal error setting up software speakup"
909             eend 1
910             return 1
911          fi
912          eoutdent
913       fi
914
915       if [ -d /proc/speakup/ ] || grep -q speakup_soft /proc/modules ; then
916          einfo "Kernel supports speakup." ; eend 0
917          eindent
918             einfo "Just run swspeak if you want to use software synthesizer via speakup."
919             flitewrapper "Finished activating software speakup. Just run swspeak when booting finished."
920          eoutdent
921       else
922          eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
923          flitewrapper "Kernel does not seem to support speakup. Sorry."
924       fi
925    fi
926 }
927 # }}}
928
929 # {{{ support hardware synthesizer via speakup
930 config_hwspeak(){
931    if checkbootparam 'speakup.synth' ; then
932       einfo "Bootoption speakup.synth found."
933       eindent
934
935       module="$(getbootparam 'speakup.synth' 2>>$DEBUG)"
936       if [ -z "$module" ] ; then
937          eerror "Sorry, no speakup module specified for bootoption speakup.synth."
938          flitewrapper "Sorry, no speakup module specified for bootoption speakup.synth."
939       else
940          einfo "Trying to load $module"
941          modprobe "speakup_${module}"
942          eend $?
943       fi
944
945       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
946          einfo "Kernel should support speakup now." ; eend 0
947          flitewrapper "Kernel should support speakup now."
948       else
949          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
950          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
951       fi
952
953       eoutdent
954
955    # hwspeak:
956    elif checkbootparam 'hwspeak' ; then
957       einfo "Bootoption hwspeak found."
958
959       if [ ! -d /proc/speakup/ ] && ! grep -q speakup /proc/modules ; then
960          ewarn "Kernel does not support hardware speakup - trying to load kernel modules:" ; eend 0
961          eindent
962          if ! [ -d "/lib/modules/${KERNEL}/extra/speakup/" ] ; then
963             eerror "Kernel does not provide speakup modules, sorry." ; eend 1
964          else
965            for module in $(find "/lib/modules/${KERNEL}/extra/speakup/" -name \*.ko | \
966                            sed 's#.*speakup/##g ; s#.ko$##g' | \
967                            grep -ve speakup_soft -ve speakup_dummy | sort -u) ; do
968               einfo "Trying to load $module"
969               modprobe $module
970               eend $?
971            done
972          fi
973          eoutdent
974       fi
975
976       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
977          einfo "Kernel should support speakup now." ; eend 0
978          flitewrapper "Kernel should support speakup now."
979       else
980          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
981          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
982       fi
983    fi
984 }
985 # }}}
986
987 # {{{ Check for blind option or brltty
988 config_blind(){
989 BLIND=""
990 checkbootparam 'blind' && BLIND="yes"
991 BRLTTY="$(getbootparam 'brltty' 2>>$DEBUG)"
992
993 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
994   if [ -x /sbin/brltty ]; then
995     # Blind option detected, start brltty now.
996     # modprobe serial_core parport_serial generic_serial && echo "done"
997     CMD=brltty
998     BRLTYPE=""
999     BRLDEV=""
1000     BRLTEXT=""
1001     if [ -n "$BRLTTY" ]; then
1002       # Extra options
1003       BRLTYPE="${BRLTTY%%,*}"
1004       R="${BRLTTY#*,}"
1005       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1006         BRLTTY="$R"
1007         BRLDEV="${BRLTTY%%,*}"
1008         R="${BRLTTY#*,}"
1009         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1010           BRLTTY="$R"
1011           BRLTEXT="${BRLTTY%%,*}"
1012           R="${BRLTTY#*,}"
1013         fi
1014       fi
1015     fi
1016     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
1017     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
1018     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
1019     einfo "Starting braille-display manager."
1020 #    ( exec $CMD & )
1021     ( sh -c "$CMD" & )
1022     sleep 2 && BLINDSOUND="yes"
1023     eend 0
1024   fi
1025 fi
1026 }
1027 # }}}
1028
1029 # {{{ AGP
1030 config_agp(){
1031 if checkbootparam 'forceagp' ; then
1032 # Probe for AGP. Hope this can fail safely
1033   grep -q "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
1034 fi
1035 }
1036 # }}}
1037
1038 # {{{ automount(er)
1039 config_automounter(){
1040 if checkbootparam 'automounter' ; then
1041   RUNLEVEL="$(runlevel)"
1042   AUTOMOUNTER=""
1043   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
1044
1045 addautomount(){
1046 # /dev/ice  options
1047   d="${1##*/}"
1048   if [ -n "$AUTOMOUNTER" ]; then
1049     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
1050     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
1051     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
1052     anew="$d        -fstype=auto,$2 :$i"
1053     grep -q "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
1054     AUTOMOUNTS="$AUTOMOUNTS $d"
1055     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
1056   else
1057     [ -d /mnt/$d ] && mkdir -p /mnt/$d
1058     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
1059   fi
1060   grep -q "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
1061 }
1062
1063   AUTOMOUNTS="floppy cdrom"
1064 # Add new devices to /etc/fstab and /etc/auto.mnt
1065   for i in /dev/cdrom?*; do
1066     if [ -L $i ]; then
1067       addautomount "$i" "ro"
1068     fi
1069   done
1070 fi
1071
1072 if [ -n "$AUTOMOUNTER" ]; then
1073 # Check for floppy dir, reinstall with automounter
1074   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
1075   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
1076   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
1077   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
1078   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
1079   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
1080   rm -f /etc/fstab.new
1081 # Replace paths from bootfloppy
1082   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
1083   mv -f /etc/fstab.new /etc/fstab
1084 # Start automounter now
1085   einfo "Starting automounter for ${AUTOMOUNTS}."
1086   /etc/init.d/autofs start >>$DEBUG ; eend $?
1087 fi
1088 }
1089 # }}}
1090
1091 # {{{ Collect partitions from /proc/partitions first for enabling DMA
1092 check_partitions(){
1093 partitions=""
1094 IDEDISKS=""
1095 while read major minor blocks partition relax; do
1096   partition="${partition##*/}"
1097   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
1098   case "$partition" in
1099     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
1100     sd?) ;;                                               # SCSI Harddisk, entire disk
1101 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
1102     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
1103   esac
1104 done <<EOT
1105 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
1106 EOT
1107 }
1108 check_partitions >/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
1109 # }}}
1110
1111 # {{{ Enable DMA for all IDE drives now if not disabled
1112 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
1113 config_dma(){
1114 if checkbootparam 'nodma'; then
1115   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
1116 else
1117   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
1118     if test -d /proc/ide/$d; then
1119       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
1120         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
1121         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
1122         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
1123         echo "using_dma:1" >/proc/ide/$d/settings
1124         eend 0
1125       fi
1126     fi
1127   done
1128 fi
1129 }
1130 # }}}
1131
1132 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
1133 config_fstab(){
1134
1135 NOSWAP="yes" # we do not use swap by default!
1136 if checkbootparam 'swap' || checkbootparam 'anyswap' ; then
1137    NOSWAP=''
1138    checkbootparam 'anyswap' && export ANYSWAP='yes' || export ANYSWAP=""
1139 fi
1140
1141 # Scan for swap, config, homedir - but only in live-mode
1142 if [ -z "$INSTALLED" ] ; then
1143    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1144    GRML_IMG=""
1145    GRML_SWP=""
1146    HOMEDIR="$(getbootparam 'home')"
1147    if [ -n "$partitions" ]; then
1148       while read p m f relax; do
1149         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1150         partoptions="users,exec"
1151         fnew=""
1152         # it's a swap partition?
1153         case "$f" in swap)
1154           eindent
1155           if [ -n "$NOSWAP" ]; then
1156              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1157              eend 0
1158           else
1159              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1160                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1161                      if [ -n "$ANYSWAP" ] ; then
1162                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1163                         swapon $p 2>>$DEBUG ; eend $?
1164                      else
1165                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1166                      fi
1167                      ;;
1168                    *)
1169                      if [[ "$p" == LABEL* ]] ; then
1170                         p=$(blkid -t $p | awk -F: '{print $1}')
1171                      fi
1172                      if grep -q $p /proc/swaps ; then
1173                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1174                      else
1175                         if [ -b "$p" ] ; then
1176                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1177                         swapon $p 2>>$DEBUG ; eend $?
1178                         else
1179                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1180                         fi
1181                      fi
1182                      ;;
1183              esac # dd-check
1184           fi # -n "$NOSWAP
1185           eoutdent
1186           continue
1187           ;;
1188         esac # it's a swap partition?
1189
1190         # mount read-only
1191         MOUNTOPTS="ro"
1192         case "$f" in
1193           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1194           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1195           *) continue ;;
1196           # *) NONEFOUND='1'; continue ;;
1197         esac
1198
1199         # use a swapfile
1200         if [ -z "$NOSWAP" ] ; then
1201            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1202            # Activate swapfile, if exists
1203            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1204         fi
1205         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1206            mount -o remount,rw $m && MOUNTED=1
1207            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1208               eindent
1209                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1210               eoutdent
1211               fnew="$SWAPFILE swap swap defaults 0 0"
1212               grep -q "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1213               GRML_SWP="$GRML_SWP $SWAPFILE"
1214               eend 0
1215            fi
1216            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1217         fi
1218
1219         # use a image as home
1220         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1221         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1222            if [ -n "$HOMEDIR" ]; then
1223               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1224                  continue
1225               fi
1226            fi
1227            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1228               GRML_IMG="$IMAGE"
1229               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1230            fi
1231         fi
1232         eend 0
1233
1234         # Umount, if not in use
1235         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1236
1237       done <<EOT
1238       $(cat /etc/fstab)
1239 EOT
1240    fi # -n $partitions
1241 fi # -z $INSTALLED
1242 }
1243 # }}}
1244
1245 # {{{ Mouse
1246 config_mouse(){
1247 if [ -n "$MOUSE_DEVICE" ] ; then
1248   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1249 fi
1250 }
1251 # }}}
1252
1253 # {{{ IPv6 configuration
1254 # Load IPv6 kernel module and print IP adresses
1255 config_ipv6(){
1256 if checkbootparam 'ipv6'; then
1257   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1258   modprobe ipv6
1259   # we probably need some time until stateless autoconfiguration has happened
1260   sleep 2
1261   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1262   for DEVICE in `echo "$NETDEVICES"`; do
1263     eindent
1264       einfo "$DEVICE:"
1265       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1266       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1267       eindent
1268         for ADDR in `echo "$ADDRESSES"` ; do
1269             einfo "$ADDR"
1270         done
1271         if [ "$COUNT" -eq "0" ] ; then
1272            einfo "(none)" ; eend 1
1273         fi
1274       eoutdent
1275     eoutdent
1276   done
1277   eend 0
1278 fi
1279 }
1280 # }}}
1281
1282 # {{{ CPU-detection
1283 config_cpu(){
1284 if checkbootparam 'nocpu'; then
1285   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1286   return 0
1287 fi
1288
1289 if [[ $(grep -c processor /proc/cpuinfo) -gt 1 ]] ; then
1290    einfo "Detecting CPU:"
1291    CPU=$(awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1292    echo $CPU | sed 's/ \{1,\}/ /g'
1293    eend 0
1294 else
1295    einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1296 fi
1297
1298 # Virtual Box supports ACPI and laptop-detect would return with '0', so check for it:
1299 if [ -r /proc/acpi/battery/BAT0/info ] && grep -q 'OEM info:.*innotek' /proc/acpi/battery/BAT0/info ; then
1300    einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1301    return 0
1302 fi
1303
1304 if [ -x /etc/init.d/loadcpufreq ] ; then
1305    einfo "Trying to set up cpu frequency scaling:"
1306    eindent
1307    SKIP_CPU_GOVERNOR=''
1308    LOADCPUFREQ=$(mktemp)
1309    /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1310    if grep -q FATAL "$LOADCPUFREQ" ; then
1311       eindent
1312         SKIP_CPU_GOVERNOR=1
1313         oldIFS="$IFS"
1314         IFS="
1315 "
1316          for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1317              eerror "$line" ; eend $RC
1318          done
1319          IFS="$oldIFS"
1320       eoutdent
1321    elif grep -q done "$LOADCPUFREQ" ; then
1322       MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1323       if [ -n "$MODULE" -a "$MODULE" != none ]; then
1324          einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1325       else
1326          ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1327       fi
1328    fi
1329
1330    rm -f $LOADCPUFREQ
1331
1332    if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1333       einfo "Loading cpufreq_ondemand, setting ondemand governor"
1334       RC=0
1335       if modprobe cpufreq_ondemand ; RC=$? ; then
1336          for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1337             echo ondemand > $file
1338          done
1339       fi
1340       eend $RC
1341    fi # cpu-governor
1342
1343    eoutdent
1344 fi
1345 }
1346 # }}}
1347
1348 # {{{ autostart of ssh
1349 config_ssh(){
1350 if checkbootparam 'ssh' ; then
1351    SSH_PASSWD=''
1352    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1353    einfo "Bootoption ssh found, trying to set password for user grml."
1354    eindent
1355    if [ -z "$SSH_PASSWD" ] ; then
1356       if [ -x /usr/bin/apg ] ; then
1357          SSH_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1358       elif [ -x /usr/bin/gpw ] ; then
1359          SSH_PASSWD="$(gpw 1)"
1360       elif [ -x /usr/bin/pwgen ] ; then
1361          SSH_PASSWD="$(pwgen -1 8)"
1362       elif [ -x /usr/bin/hexdump ] ; then
1363          SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1364       elif [ -n "$RANDOM" ] ; then
1365          SSH_PASSWD="grml${RANDOM}"
1366       else
1367          SSH_PASSWD=''
1368          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1369          eend 1
1370       fi
1371
1372       if [ -n "$SSH_PASSWD" ] ; then
1373          ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
1374       fi
1375    fi
1376    eoutdent
1377
1378    # finally check if we have a password we can use:
1379    if [ -n "$SSH_PASSWD" ] ; then
1380       # chpasswd sucks, seriously.
1381       if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
1382         echo "grml:$SSH_PASSWD" | chpasswd -m
1383       else
1384         echo "grml:$SSH_PASSWD" | chpasswd
1385       fi
1386    fi
1387
1388    einfo 'Starting secure shell server in background.'
1389    /etc/init.d/rmnologin start >>$DEBUG 2>>$DEBUG
1390    /etc/init.d/ssh start >>$DEBUG 2>>$DEBUG &
1391    eend $?
1392
1393    eindent
1394    ewarn 'Warning: please change the password for user grml as soon as possible!'
1395    eoutdent
1396 fi
1397 }
1398 # }}}
1399
1400 # {{{ autostart of x11vnc
1401 config_vnc(){
1402
1403 USER=grml # TODO: make it dynamically configurable
1404 if checkbootparam 'vnc' ; then
1405    VNC_PASSWD=''
1406    VNC_PASSWD="$(getbootparam 'vnc' 2>>$DEBUG)"
1407    einfo "Bootoption vnc found, trying to set password for user $USER."
1408    eindent
1409    if [ -z "$VNC_PASSWD" ] ; then
1410       if [ -x /usr/bin/apg ] ; then
1411          VNC_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1412       elif [ -x /usr/bin/gpw ] ; then
1413          VNC_PASSWD="$(gpw 1)"
1414       elif [ -x /usr/bin/pwgen ] ; then
1415          VNC_PASSWD="$(pwgen -1 8)"
1416       elif [ -x /usr/bin/hexdump ] ; then
1417          VNC_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1418       elif [ -n "$RANDOM" ] ; then
1419          VNC_PASSWD="${USER}${RANDOM}"
1420       else
1421          VNC_PASSWD=''
1422          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1423          eend 1
1424       fi
1425
1426       if [ -n "$VNC_PASSWD" ] ; then
1427          ewarn "No given password for vnc found. Using random password: $VNC_PASSWD" ; eend 0
1428       fi
1429    fi
1430    eoutdent
1431
1432    # finally check if we have a password we can use:
1433    if [ -n "$VNC_PASSWD" ] ; then
1434
1435       VNCDIR="/home/${USER}/.vnc"
1436       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1437
1438       if [ ! -x /usr/bin/x11vnc ] ; then
1439          eerror "Error: x11vnc not found - can not set up vnc. Please make sure to install the x11vnc package."
1440          eend 1
1441       else
1442          /usr/bin/x11vnc -storepasswd "$VNC_PASSWD" "$VNCDIR"/passwd ; eend $?
1443          /bin/chown -R "$USER": "$VNCDIR"
1444       fi
1445    fi
1446    if checkbootparam 'vnc_connect' ; then
1447       VNC_CONNECT=''
1448       VNC_CONNECT="$(getbootparam 'vnc_connect' 2>>$DEBUG)"
1449       einfo "Bootoption vnc_connect found, will start vnc with connect to $VNC_CONNECT."
1450       #store the options in a file
1451       VNCDIR="/home/${USER}/.vnc"
1452       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1453       echo " --connect $VNC_CONNECT " >> $VNCDIR/options
1454    fi
1455 fi
1456 }
1457 # }}}
1458
1459 # {{{ set password for user grml
1460 config_passwd(){
1461 if checkbootparam 'passwd' >>$DEBUG 2>&1; then
1462   einfo "Bootoption passwd found."
1463   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1464   if [ -n "$PASSWD" ] ; then
1465     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1466   else
1467     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1468   fi
1469   eindent
1470     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1471   eoutdent
1472 fi
1473 }
1474 # }}}
1475
1476 # {{{ Sound
1477 config_mixer () {
1478    if ! [ -x /usr/bin/amixer ] ; then
1479       eerror "amixer binary not available. Can not set sound volumes therefore."
1480       eend 1
1481    else
1482       if ! [ -r /proc/asound/cards ] ; then
1483          ewarn "No soundcard present, skipping mixer settings therefore."
1484          eend 0
1485          return
1486       fi
1487
1488       for card in $(cat /proc/asound/cards| grep -e '^\s*[0-9]' | awk '{print $1}') ; do
1489          einfo "Configuring soundcard \"$(awk -F\[ '/^ *'$card' \[/{ FS=" "; $0=$2; print $1}' < /proc/asound/cards)\""
1490          eindent
1491
1492          if checkbootparam 'vol' ; then
1493             VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1494             if [ -z "$VOL" ] ; then
1495                eerror "Bootoption vol found but no volume level/parameter given. Using defaults (75%)."
1496                VOL='75'
1497                eend 1
1498             fi
1499          else
1500             VOL='75'
1501          fi
1502
1503          if checkbootparam 'nosound' ; then
1504             einfo "Muting sound devices on request."
1505             ERROR=$(amixer -q set Master mute)
1506             RC=$?
1507             if [ -n "$ERROR" ] ; then
1508                eindent
1509                eerror "Problem muting sound devices: $ERROR"
1510                eoutdent
1511             fi
1512             eend $RC
1513          elif [ -z "$INSTALLED" ] ; then
1514             einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1515
1516             if checkbootparam 'micvol' ; then
1517                MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1518             else
1519                MICVOL=0
1520             fi
1521
1522             for CONTROL in Master PCM ; do
1523                if amixer -q | grep -q "Simple mixer control '$CONTROL'" ; then
1524                   amixer -q set "${CONTROL}" "${VOL}"%
1525                   eend $?
1526                fi
1527             done
1528
1529             if [ ${MICVOL} -ne 0 ] ; then
1530                einfo "Setting microphone to ${WHITE}${MICVOL}${NORMAL}."
1531                amixer -q set "Mic" $MICVOL &> /dev/null
1532                eend $?
1533             fi
1534          fi # checkbootparam 'nosound'
1535          eoutdent
1536       done
1537    fi
1538 }
1539 # }}}
1540
1541 # {{{ modem detection
1542 config_modem(){
1543 if checkbootparam 'nomodem'; then
1544   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1545 else
1546   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1547      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1548         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1549         eend 0
1550      fi
1551   fi
1552 fi
1553 }
1554 # }}}
1555
1556 # {{{ wondershaper
1557 config_wondershaper(){
1558  if checkbootparam 'wondershaper' ; then
1559     WONDER="$(getbootparam 'wondershaper' 2>>$DEBUG)"
1560     CMD=wondershaper
1561     DEVICE=""
1562     DOWNSTREAM=""
1563     UPSTREAM=""
1564     if [ -n "$WONDER" ]; then
1565       # Extra options
1566       DEVICE="${WONDER%%,*}"
1567       R="${WONDER#*,}"
1568       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1569         WONDER="$R"
1570         DOWNSTREAM="${WONDER%%,*}"
1571         R="${WONDER#*,}"
1572         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1573           WONDER="$R"
1574           UPSTREAM="${WONDER%%,*}"
1575           R="${WONDER#*,}"
1576         fi
1577       fi
1578     fi
1579     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1580     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1581     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1582     einfo "Starting wondershaper (${CMD}) in background."
1583     ( sh -c $CMD & ) && eend 0
1584  fi
1585 }
1586 # }}}
1587
1588 # {{{ syslog-ng
1589 config_syslog(){
1590  if checkbootparam 'nosyslog'; then
1591     ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
1592  else
1593     SYSLOGD=''
1594     [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
1595     [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
1596     [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
1597     [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
1598     [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
1599
1600     if [ -z "$SYSLOGD" ] ; then
1601        eerror "No syslog daemon found." ; eend 1
1602     else
1603        einfo "Starting $SYSLOGD in background."
1604        /etc/init.d/$SYSLOGD start >>$DEBUG &
1605        eend 0
1606     fi
1607  fi
1608 }
1609 # }}}
1610
1611 # {{{ gpm
1612 config_gpm(){
1613  if checkbootparam 'nogpm'; then
1614   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1615  else
1616    if ! [ -r /dev/input/mice ] ; then
1617       eerror "No mouse found - not starting GPM." ; eend 1
1618    else
1619       einfo "Starting gpm in background."
1620       /etc/init.d/gpm start >>$DEBUG &
1621       # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start >>$DEBUG ) &
1622       eend 0
1623    fi
1624  fi
1625 }
1626 # }}}
1627
1628 # {{{ services
1629 config_services(){
1630  if checkbootparam 'services' ; then
1631     SERVICE="$(getbootparam 'services' 2>>$DEBUG)"
1632     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1633     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1634     einfo "Starting service(s) ${SERVICENL} in background."
1635     for service in $(echo -e $SERVICELIST) ; do
1636        /etc/init.d/${service} start >>$DEBUG &
1637     done
1638     [ "$?" == "0" ] ; eend $?
1639  fi
1640 }
1641 # }}}
1642
1643 # {{{ remote files
1644 get_remote_file() {
1645   [ "$#" -eq 2 ] || ( echo "Error: wrong parameter for get_remote_file()" ; return 1 )
1646   SOURCE=$(eval echo "$1")
1647   TARGET="$2"
1648   getconfig() {
1649   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 --tries=1 \
1650        --read-timeout=10 ${SOURCE} -O ${TARGET} && return 0 || return 1
1651   }
1652   einfo "Trying to get ${WHITE}${TARGET}${NORMAL}"
1653   counter=10
1654   while ! getconfig && [[ "$counter" != 0 ]] ; do
1655     echo -n "Sleeping for 1 second and trying to get config again... "
1656     counter=$(( counter-1 ))
1657     echo "$counter tries left" ; sleep 1
1658   done
1659   if [ -s "$TARGET" ] ; then
1660     einfo "Downloading was successfull." ; eend 0
1661     einfo "md5sum of ${WHITE}${TARGET}${NORMAL}: "
1662     md5sum ${TARGET} ; eend 0
1663     return 0;
1664   else
1665     einfo "Sorry, could not fetch ${SOURCE}" ; eend 1
1666     return 1;
1667  fi
1668 }
1669 # }}}
1670
1671 # {{{ config files
1672 config_netconfig(){
1673  if checkbootparam 'netconfig' ; then
1674   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1675   CONFIGFILE='/tmp/netconfig.grml'
1676
1677   if get_remote_file ${CONFIG} ${CONFIGFILE} ; then
1678     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1679   fi
1680
1681  fi
1682 }
1683 # }}}
1684
1685 # {{{ remote scripts
1686 config_netscript() {
1687  if checkbootparam 'netscript' ; then
1688   CONFIG="$(getbootparam 'netscript' 2>>$DEBUG)"
1689   SCRIPTFILE='/tmp/netscript.grml'
1690
1691   if get_remote_file ${CONFIG} ${SCRIPTFILE} ; then
1692     chmod +x ${SCRIPTFILE}
1693     einfo "Running ${WHITE}${SCRIPTFILE}${NORMAL}:" && NETSCRIPT=${CONFIG} ${SCRIPTFILE} ; eend $?
1694   fi
1695
1696  fi
1697 }
1698 # }}}
1699
1700 # {{{ blindsound
1701 config_blindsound(){
1702  if checkbootparam 'blind' ; then
1703     beep
1704     flitewrapper "welcome to the gremel system"
1705  fi
1706 }
1707 # }}}
1708
1709 # {{{ welcome sound
1710 config_welcome(){
1711  if checkbootparam 'welcome' ; then
1712     flitewrapper "welcome to the gremel system"
1713  fi
1714 }
1715 # }}}
1716
1717 # {{{ fix/workaround for unionfs
1718 fix_unionfs(){
1719   if [ -z "$INSTALLED" ]; then
1720    touch /var/cache/apt/*cache.bin
1721   fi
1722 }
1723 # }}}
1724
1725 # {{{ start X window system via grml-x
1726 config_x_startup(){
1727 # make sure we start X only if startx is used *before* a nostartx option
1728 # so it's possible to disable automatic X startup using nostart
1729 if checkbootparam 'startx' && ! echo "$CMDLINE" | grep -q 'startx.*nostartx' ; then
1730  if [ -x "$(which X)" ] ; then
1731   if [ -z "$INSTALLED" ] ; then
1732    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1733    if [ -z "$WINDOWMANAGER" ] ; then
1734      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1735      WINDOWMANAGER="wm-ng"
1736    else
1737      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1738    fi
1739    einfo "Setting up and invoking grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1740    config_userfstab || fstabuser='grml'
1741  cat>|/etc/init.d/xstartup<<EOF
1742 #!/bin/sh
1743 su $fstabuser -c "/usr/bin/grml-x $WINDOWMANAGER"
1744 EOF
1745    chmod 755 /etc/init.d/xstartup
1746
1747    # adjust inittab for xstartup
1748    if grep -q '^6:' /etc/inittab ; then
1749       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>\&1 </dev/tty6|' /etc/inittab
1750    else # just append tty6 to inittab if no definition is present:
1751       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>&1 < /dev/tty6' >> /etc/inittab
1752    fi
1753
1754    /sbin/telinit q ; eend $?
1755
1756    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1757       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1758    else
1759       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1760    fi
1761
1762   else
1763     eerror "We are not running in live mode - startx will not work, skipping it."
1764     eerror " -> Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1765   fi
1766  else
1767    eerror "/usr/X11R6/bin/X is not present on this grml flavour."
1768    eerror "  -> Boot parameter startx does not work therefore." ; eend 1
1769  fi
1770 fi
1771 }
1772 # }}}
1773
1774 # {{{ configuration framework
1775 config_extract(){
1776 if checkbootparam 'extract' ; then
1777  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1778  EXTRACTOPTIONS="-- -x $EXTRACT"
1779 fi
1780 }
1781
1782 config_finddcsdir() {
1783 #  - If no GRMLCFG partition is found and noautoconfig is _not_ given
1784 #    on the command line, nothing is changed and the dcs files are
1785 #    searched within the .iso, $dcs-dir is set to the root directory
1786 #    within the .iso
1787 #  - If a GRMLCFG partition is found, $dcs-dir is set to the root of
1788 #    the GRMLCFG partition unless noautoconfig is set. If noautoconfig is
1789 #    set, $dcs-dir is set to the root directory within the .iso.
1790 #  - If myconfig=foo is set on the command line, $dcs-dir is set to
1791 #    foo, even if a GRMLCFG partition is present.
1792 DCSDIR=""
1793 DCSMP="/mnt/grml"
1794 # autoconfig, see issue673
1795 GRMLCFG="$(getbootparam 'autoconfig' 2>>$DEBUG)"
1796 [ -n "$GRMLCFG" ] || GRMLCFG="GRMLCFG"
1797 if checkbootparam 'noautoconfig' || checkbootparam 'forensic' ; then
1798   ewarn "Skipping running automount of device(s) labeled $GRMLCFG as requested." ; eend 0
1799 else
1800   if [ -z "$INSTALLED" ] ; then
1801     if checkbootparam 'myconfig' ; then
1802       DCSDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1803       if [ -z "$DCSDEVICE" ]; then
1804         eerror "Error: No device for bootoption myconfig provided." ; eend 1
1805       fi # [ -z "$DCSDEVICE" ]
1806     elif checkvalue $CONFIG_MYCONFIG; then # checkbootparam myconfig
1807       einfo "Searching for device(s) labeled with $GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
1808       eindent
1809       # We do need the following fix so floppy disk is available to blkid in any case :-/
1810       if [ -r /dev/fd0 ] ; then
1811         einfo "Floppy device detected. Trying to access floppy disk."
1812         if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 >>$DEBUG 2>&1 ; then
1813            blkid /dev/fd0 >>$DEBUG 2>&1
1814         fi
1815       fi
1816       DCSDEVICE=$(blkid -t LABEL=$GRMLCFG | head -1 | awk -F: '{print $1}')
1817       if [ -n "$DCSDEVICE" ]; then
1818         DCSMP="/mnt/grmlcfg"
1819       fi
1820       eoutdent
1821     fi
1822
1823     # if not specified/present then assume default:
1824     if [ -z "$DCSDEVICE" ]; then
1825       DCSDIR="/live/image"
1826     else
1827       eindent
1828       einfo "debs, config, scripts are read from $DCSDEVICE." ; eend 0
1829       DCSDIR="$(< /proc/mounts awk -v DCSDEV=$DCSDEVICE '{if ($1 == DCSDEV) { print $2 }}')"
1830       if [ -n "$DCSDIR" ]; then
1831         ewarn "$DCSDEVICE already mounted on $DCSDIR"; eend 0
1832       else
1833         [ -d $DCSMP ] || mkdir $DCSMP
1834         umount $DCSMP >>$DEBUG 2>&1 # make sure it is not mounted
1835         mount -o ro -t auto $DCSDEVICE  $DCSMP ; RC="$?"
1836         if [[ $RC == 0 ]]; then
1837           einfo "Successfully mounted $DCSDEVICE to $DCSMP (readonly)." ; eend 0
1838         else
1839           eerror "Error: mounting $DCSDEVICE to $DCSMP (readonly) failed." ; eend 1
1840         fi
1841         DCSDIR="$DCSMP"
1842       fi
1843       eoutdent
1844     fi
1845   fi
1846 fi
1847
1848 if [ -n "$DCSDIR" -a "$DCSDIR" != "/live/image" ] ; then
1849   einfo "Debs, config, scripts (if present) will be read from $DCSDIR." ; eend 0
1850 elif checkbootparam 'debs' || checkbootparam 'config' || checkbootparam 'scripts'; then
1851   einfo "Debs, config, scripts will be read from the live image directly." ; eend 0
1852 fi
1853 }
1854
1855
1856 config_partconf() {
1857 if checkbootparam 'partconf' ; then
1858  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1859  if [ -n "$MOUNTDEVICE" ]; then
1860    [ -d /mnt/grml ] || mkdir /mnt/grml
1861    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1862     if [[ $RC == 0 ]]; then
1863       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1864       einfo "Copying files from $MOUNTDEVICE over grml system."
1865       for file in `cat /etc/grml/partconf` ; do
1866         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1867         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1868       done && eend 0
1869     else
1870       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1871     fi # mount $MOUNTDEVICE
1872    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1873  else
1874    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1875  fi # [ -n "$MOUNTDEVICE" ]
1876 fi
1877 }
1878 # }}}
1879
1880 # {{{ /cdrom/.*-options
1881 config_debs(){
1882 if checkbootparam 'debs' ; then
1883    iszsh && setopt localoptions shwordsplit
1884    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1885    if [ -z "$DEBS" ] ; then
1886       DEBS="*.deb"
1887    fi
1888    if ! echo $DEBS | grep -q '/'; then
1889      # backwards compatibility: if no path is given get debs from debs/
1890      DEBS="debs/$DEBS"
1891    fi
1892    einfo "Tring to install debian package(s) ${DEBS}"
1893    DEBS="$(eval echo ${DCSDIR}/$DEBS)"
1894    dpkg -i $DEBS ; eend $?
1895 fi
1896 }
1897
1898 config_scripts(){
1899 if checkbootparam 'scripts' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1900    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1901    if [ -d ${DCSDIR}/scripts ] && [ -z "$SCRIPTS" ]; then
1902      SCRIPTS="$(cd ${DCSDIR}/scripts; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1903    fi
1904    if ! echo $SCRIPTS | grep -q '/'; then
1905      # backwards compatibility: if no path is given get scripts from scripts/
1906      SCRIPTS="scripts/$SCRIPTS"
1907    fi
1908    if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1909      # we are executing from a GRMLCFG labeled fs
1910      # kick everything we have done before and start over
1911      SCRIPTS="$(cd ${DCSDIR}; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1912    fi
1913    if [ -n "$SCRIPTS" ]; then
1914      SCRIPTS="${DCSDIR}/$SCRIPTS"
1915      if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1916        einfo "Trying to execute ${SCRIPTS}"
1917        sh -c $SCRIPTS
1918      elif [ -d "$SCRIPTS" ]; then
1919        einfo "Bootparameter scripts found. Trying to execute from directory ${SCRIPTS}:"
1920        run-parts $SCRIPTS
1921      else
1922        einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1923        sh -c $SCRIPTS
1924      fi
1925    fi
1926 fi
1927 }
1928
1929 config_config(){
1930 if checkbootparam 'config' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1931   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1932   if [ -z "$CONFIG" ]; then
1933     CONFIG="$(cd ${DCSDIR}; ls -1d [Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1934   fi
1935   if [ -n "$CONFIG" ]; then
1936     if [ -d "${DCSDIR}/${CONFIG}" ] ; then
1937       einfo "Taking configuration from directory ${DCSDIR}/${CONFIG}"
1938
1939       cp -a ${DCSDIR}/${CONFIG}/* /
1940     elif [ -f "${DCSDIR}/${CONFIG}" ]; then
1941       einfo "Extracting configuration from file ${DCSDIR}/${CONFIG}"
1942
1943       cd /
1944       unp ${DCSDIR}/${CONFIG} $EXTRACTOPTIONS ; eend $?
1945     else
1946       ewarn "Sorry, could not find configuration file or directory ${DCSDIR}/${FILENAME}." ; eend 1
1947     fi
1948   fi
1949 fi
1950 # umount $DCSMP if it was mounted by finddcsdir
1951 # this doesn't really belong here
1952 grep -q '$DCSMP' /proc/mounts && umount $DCSMP
1953 }
1954 # }}}
1955
1956 # {{{ mypath
1957 config_mypath(){
1958 if checkbootparam 'mypath' ; then
1959    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
1960    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
1961    touch /etc/grml/my_path
1962    chmod 644 /etc/grml/my_path
1963    # make sure the directories exist:
1964    eindent
1965    for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
1966        if ! [ -d "$i" ] ; then
1967           einfo "Creating directory $i"
1968           mkdir -p "$i" ; eend $?
1969        fi
1970    done
1971    grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
1972    eoutdent
1973 fi
1974 }
1975 # }}}
1976
1977 # {{{ distcc
1978 config_distcc(){
1979 if checkbootparam 'distcc' ; then
1980  OPTIONS="$(getbootparam 'distcc' 2>>$DEBUG)"
1981  if [ -n "$OPTIONS" ]; then
1982     NET=""
1983     INTERFACE=""
1984     if [ -n "$OPTIONS" ]; then
1985       NET="${OPTIONS%%,*}"
1986       R="${OPTIONS#*,}"
1987       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1988         OPTIONS="$R"
1989         INTERFACE="${OPTIONS%%,*}"
1990         R="${OPTIONS#*,}"
1991       fi
1992     fi
1993  fi
1994  CONFIG=/etc/default/distcc
1995  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1996  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1997
1998  if [ -n "$INTERFACE" ] ; then
1999    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2000
2001    counter=10
2002    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
2003      counter=$(( counter-1 ))
2004      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
2005      sleep 3
2006      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2007    done
2008  fi
2009
2010  if [ -n "$IP" ] ; then
2011    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
2012
2013    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
2014    eindent
2015     id distccd >/dev/null 2>&1 || \
2016     (
2017       einfo "Creating distcc user" ; \
2018       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
2019     )
2020
2021     einfo "Starting distcc for network ${NET}, listening on ${IP}."
2022    /etc/init.d/distcc start >/dev/null ; eend $?
2023    eoutdent
2024  else
2025    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
2026  fi
2027 fi
2028
2029 if checkbootparam 'gcc'; then
2030  GCC="$(getbootparam 'gcc' 2>>$DEBUG)"
2031  eindent
2032  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
2033  eoutdent
2034  rm -f /usr/bin/gcc
2035  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
2036 fi
2037
2038 if checkbootparam 'gpp'; then
2039  GPP="$(getbootparam 'gpp' 2>>$DEBUG)"
2040  eindent
2041   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
2042   if [ -x /usr/bin/g++-${GPP} ] ; then
2043      rm -f /usr/bin/g++
2044      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
2045   fi
2046   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
2047   if [ -x /usr/bin/cpp-${GPP} ] ; then
2048      rm -f /usr/bin/cpp
2049      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
2050   fi
2051  eoutdent
2052 fi
2053
2054 }
2055 # }}}
2056
2057 # {{{ load modules
2058 # Notice: use it only on live-cd system, if running from harddisk please
2059 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2060 # in /etc/runlevel.conf
2061 config_modules(){
2062 MODULES_FILE=/etc/grml/modules
2063 if checkbootparam 'nomodules' ; then
2064   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2065 elif [ -z "$INSTALLED" ]; then
2066  if [ -r $MODULES_FILE ] ; then
2067   einfo "Loading modules specified in ${MODULES_FILE}:"
2068   eindent
2069   grep '^[^#]' $MODULES_FILE | \
2070   while read module args; do
2071     [ "$module" ] || continue
2072       einfo "${module}"
2073       modprobe $module $args ; eend $?
2074   done
2075   eoutdent
2076  else
2077   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2078  fi
2079 fi
2080 }
2081 # }}}
2082
2083 # {{{ 915resolution
2084 config_915resolution(){
2085 if checkbootparam '915resolution' ; then
2086  OPTIONS="$(getbootparam '915resolution' 2>>$DEBUG)"
2087   if [ -x /usr/sbin/915resolution ]; then
2088     CMD=915resolution
2089     MODE=""
2090     XRESO=""
2091     YRESO=""
2092     if [ -n "$OPTIONS" ]; then
2093       # Extra options
2094       MODE="${OPTIONS%%,*}"
2095       R="${OPTIONS#*,}"
2096       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2097         OPTIONS="$R"
2098         XRESO="${OPTIONS%%,*}"
2099         R="${OPTIONS#*,}"
2100         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2101           OPTIONS="$R"
2102           YRESO="${OPTIONS%%,*}"
2103           R="${OPTIONS#*,}"
2104         fi
2105       fi
2106     fi
2107     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2108     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2109     eend 0
2110   fi
2111 fi
2112 }
2113 # }}}
2114
2115 # {{{ SW-RAID
2116 config_swraid(){
2117   [ -n "$INSTALLED" ] && return 0
2118
2119   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2120   if checkbootparam 'noraid'   || checkbootparam 'noswraid' || \
2121      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2122      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2123   else
2124     if ! [ -x /sbin/mdadm ] ; then
2125        eerror "mdadm not available, can not execute it." ; eend 1
2126     else
2127
2128        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2129        # find out whether we have a valid configuration file already
2130        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2131           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2132           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2133           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2134         else
2135           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2136        fi
2137
2138        if ! checkbootparam 'swraid' ; then
2139           eindent
2140           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2141           eoutdent
2142        else
2143           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2144           eindent
2145            IFSOLD=${IFS:-}
2146            IFS='
2147 '
2148            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2149                case $line in
2150                  *'No arrays found'*)
2151                    ewarn "$line" ; eend 0
2152                    ;;
2153                  *)
2154                    einfo "$line" ; eend 0
2155                    ;;
2156                esac
2157            done
2158            IFS=$IFSOLD
2159          eoutdent
2160
2161          if [ -r /proc/mdstat ] ; then
2162             eindent
2163             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2164             if [ -z "$MDSTAT" ] ; then
2165                ewarn "No active arrays found" ; eend 0
2166             else
2167                IFSOLD=${IFS:-}
2168                IFS='
2169 '
2170                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2171                    einfo "active arrays: $line" ; eend 0
2172                done
2173                IFS=$IFSOLD
2174             fi
2175             eoutdent
2176          fi # /proc/mdstat
2177        fi # bootoption swraid
2178
2179      fi # is /sbin/mdadm executable?
2180   fi # check for bootoptions
2181 }
2182 # }}}
2183
2184 # {{{ dmraid
2185 config_dmraid(){
2186   [ -n "$INSTALLED" ] && return 0
2187
2188   if checkbootparam 'nodmraid' ; then
2189     ewarn "Skipping dmraid code as requested on boot commandline." ; eend 0
2190     return 0
2191   fi
2192
2193   if ! [ -x /sbin/dmraid ] ; then
2194     eerror "dmraid not available, can not execute it." ; eend 1
2195     return
2196   fi
2197
2198   dmraid_wrapper() {
2199     # usage: dmraid_wrapper <dmraid_option>
2200     [ -n "$1" ] || return 1
2201
2202     IFSOLD=${IFS:-}
2203     IFS='
2204 '
2205     eindent
2206
2207     for line in $(dmraid $1 ; echo errcode:$?); do
2208       case $line in
2209         *'no block devices found'*)
2210           einfo "No block devices found" ; eend 0
2211           break
2212           ;;
2213         *'no raid disks'*)
2214           einfo "No active dmraid devices found" ; eend 0
2215           break
2216           ;;
2217         errcode:0)
2218           eend 0;
2219           ;;
2220         errcode:1)
2221           eend 1
2222           ;;
2223         *)
2224           einfo "$line"
2225           ;;
2226       esac
2227     done
2228
2229     eoutdent
2230     IFS=$IFSOLD
2231   }
2232
2233   if checkbootparam 'dmraid' ; then
2234     local ACTION="$(getbootparam 'dmraid' 2>>$DEBUG)"
2235     if [ "$ACTION" = "off" ] ; then
2236       # Deactivates all active software RAID sets:
2237       einfo "Deactivating present dmraid sets (as requested via dmraid=off):"
2238       dmraid_wrapper -an
2239     else
2240       # Activate all software RAID sets discovered:
2241       einfo "Activating present dmraid sets (as requested via dmraid):"
2242       dmraid_wrapper -ay
2243     fi
2244
2245     return
2246   fi
2247
2248   # by default (no special bootoptions) discover all software RAID devices:
2249   einfo "Searching for any present dmraid sets:"
2250   dmraid_wrapper -r
2251 }
2252 # }}}
2253
2254 # {{{ LVM (Logical Volumes)
2255 config_lvm(){
2256   [ -n "$INSTALLED" ] && return 0
2257
2258   if checkbootparam 'nolvm' ; then
2259      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2260   else
2261     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2262     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2263        eerror "LVM not available, can not execute it." ; eend 1
2264     else
2265        if lvdisplay 2>&1 | grep -v 'No volume groups found' >/dev/null 2>&1 ; then
2266           einfo "You seem to have logical volumes (LVM) on your system."
2267           eindent
2268           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2269           eend 0
2270           if checkbootparam 'lvm' ; then
2271              einfo "Bootoption LVM found. Searching for logical volumes:"
2272              /etc/init.d/lvm2 start ; eend $?
2273           fi
2274           eoutdent
2275        fi
2276     fi # check for lvm binary
2277   fi # check for bootoption nolvm
2278 }
2279 # }}}
2280
2281 # {{{ debnet: setup network based on an existing one found on a partition
2282 config_debnet(){
2283 if checkbootparam 'debnet' ; then
2284  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2285  /usr/sbin/debnet
2286 fi
2287 }
2288 # }}}
2289
2290 # {{{ disable console blanking
2291 config_blanking(){
2292 if checkbootparam 'noblank' ; then
2293   einfo "Bootoption noblank found. Disabling monitor blanking."
2294   setterm -blank 0 ; eend $?
2295 fi
2296 }
2297 # }}}
2298
2299 # {{{ tohd= bootoption
2300 config_tohd()
2301 {
2302   if checkbootparam 'tohd' ; then
2303      local TARGET="$(getbootparam 'tohd' 2>>$DEBUG)"
2304      if [ -z "$TARGET" ] ; then
2305         eerror "Error: tohd specified without any partition, can not continue." ; eend 1
2306         eerror "Please use something like tohd=/dev/sda9." ; eend 1
2307         return 1
2308      fi
2309
2310      if ! [ -b "$TARGET" ] ; then
2311         eerror "Error: $TARGET is not a valid block device, sorry." ; eend 1
2312         return 1
2313      fi
2314
2315      if grep -q $TARGET /proc/mounts ; then
2316         eerror "$TARGET already mounted, skipping execution of tohd therefore."
2317         eend 1
2318         return 1
2319      fi
2320
2321      local MOUNTDIR=$(mktemp -d)
2322
2323      if mount -o rw "$TARGET" "$MOUNTDIR" ; then
2324         einfo "Copyring live system to $TARGET - this might take a while"
2325         rsync -a --progress /live/image/live $MOUNTDIR
2326         sync
2327         umount "$MOUNTDIR"
2328         eend $?
2329         einfo "Booting with \"grml bootfrom=$TARGET\" should work now." ; eend 0
2330      else
2331         eerror "Error when trying to mount $TARGET, sorry."; eend 1
2332         return 1
2333      fi
2334
2335      rmdir "$MOUNTDIR"
2336   fi
2337 }
2338 # }}}
2339
2340 # {{{ grml2hd: automatic installation
2341 config_grml2hd(){
2342
2343 if checkbootparam "grml2hd" || checkbootparam "BOOT_IMAGE=grml2hd" ; then
2344
2345 if checkbootparam 'user' ; then
2346    NEWUSER=''
2347    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2348    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2349 fi
2350
2351 if checkbootparam 'filesystem' ; then
2352    FILESYSTEM=''
2353    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2354    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2355 fi
2356
2357 if checkbootparam 'partition' ; then
2358    PARTITION=''
2359    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2360    # notice: the following checks whether the given partition is available, if not the skip
2361    # execution of grml2hd as it might result in data loss...
2362    if [ -r $PARTITION ] ; then
2363       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2364    else
2365       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2366    fi
2367 fi
2368
2369 if checkbootparam 'mbr' ; then
2370    BOOT_PARTITION=''
2371    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2372    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2373 fi
2374
2375 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2376 #!/bin/sh
2377 GRML2HD_NONINTERACTIVE='yes' grml2hd
2378 EOF
2379
2380 chmod 755 /usr/bin/grml2hd_noninteractive
2381 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2382 if [ -z "$GRML2HD_FAIL" ] ; then
2383    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2384 else
2385    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2386 fi
2387
2388 fi # if checkbootparam "BOOT_IMAGE=grml2hd ...
2389 }
2390 # }}}
2391
2392 # {{{ debootstrap: automatic installation
2393 config_debootstrap(){
2394
2395 if checkbootparam "BOOT_IMAGE=debian2hd" || checkbootparam "debian2hd" ; then
2396
2397 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2398
2399 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2400    eindent
2401    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2402    eoutdent
2403    exit 1
2404 fi
2405
2406 if checkbootparam 'target' ; then
2407   TARGET=''
2408   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2409   # notice: the following checks whether the given partition is available, if not the skip
2410   # execution of grml-debootstrap as it might result in data loss...
2411   if ! [ -r "$TARGET" ] ; then
2412      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2413   fi
2414 else
2415   eindent
2416   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2417   eoutdent
2418   exit 1
2419 fi
2420
2421 if checkbootparam 'grub' ; then
2422   GRUB=''
2423   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2424 fi
2425
2426 if checkbootparam 'groot' ; then
2427   GROOT=''
2428   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2429 fi
2430
2431 if checkbootparam 'release' ; then
2432   RELEASE=''
2433   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2434 fi
2435
2436 if checkbootparam 'mirror' ; then
2437   MIRROR=''
2438   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2439 fi
2440
2441 if checkbootparam 'boot_append' ; then
2442   BOOT_APPEND=''
2443   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2444 fi
2445
2446 if checkbootparam 'password' ; then
2447   PASSWORD=''
2448   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2449 fi
2450
2451 # now check which options are available
2452 if [ -n "TARGET" ] ; then
2453    TARGETCMD="--target $TARGET"
2454 else
2455    TARGETCMD=''
2456    eindent
2457    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2458    eoutdent
2459    exit 1
2460 fi
2461 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2462 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2463 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2464 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2465 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2466 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2467
2468 # and finally write script and execute it
2469 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2470 #!/bin/sh
2471 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2472 EOF
2473
2474 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2475
2476 screen /usr/bin/grml-debootstrap_noninteractive
2477 einfo "Invoking a shell, just exit to continue booting..."
2478 /bin/zsh
2479
2480 fi # checkbootparam "BOOT_IMAGE=debian2hd
2481 }
2482 # }}}
2483
2484 # {{{ Support customization
2485 config_distri(){
2486 if checkbootparam 'distri'; then
2487   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2488   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2489      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2490      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2491      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2492      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2493   fi
2494 fi
2495 }
2496 # }}}
2497
2498 ## END OF FILE #################################################################
2499 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3